//JohnGs tube class
//<http://www.hardcorepawn.com/Anenome/>
//Simple tube, currently fixed radius, could be tapered fairly easily though.
//Provide 2 verticies for the middle of the ends of the tube, a radius, and a colour.
class Cylinder{
  Vec3 root, end;
  Quad[] polys;
  float r1,r2;
  float heading, pitch;
  int sides;

  //calculate all the poly's now, instead of in draw(), MASSIVE speedup.
  Cylinder(Vec3 _root, Vec3 _end, float _r1, float _r2, int sides){
  this.sides = sides;
    polys=new Quad[sides];
    root=_root;
    end=_end;
    r1=_r1;
    r2=_r2;
    
    //set up some useful values for later.
    float len=sqrt((end.x-root.x)*(end.x-root.x)+(end.y-root.y)*(end.y-root.y)+(end.z-root.z)*(end.z-root.z));
    len/=2;
    Vec3 vec=new Vec3((end.x-root.x),(end.y-root.y),(end.z-root.z));
    Vec3 mid=new Vec3((root.x+end.x)/2,(root.y+end.y)/2,((root.z+end.z)/2));
    heading=atan2(vec.z,vec.x);
    //HACK.. but seems necessary.. probably balances bug in code below....
    heading=0-heading;
    //ENDHACK
    pitch=atan2(vec.y,sqrt((vec.x*vec.x)+(vec.z*vec.z)));

    //can probably merge all 4 stages into one.
    //they'll be some really long lines though.
    //tube Vec3 coords worked out by first generating a horizontal tube, of the right length, and then
    //rotating, and moving it until it's in the right place.
    for(int j = 0; j < sides ;j++)
    { 
      // rod is horizontal along X to start
      Vec3[] a = new Vec3[4];
      a[0]=new Vec3(len,r2*cos(j*(TWO_PI/sides)),r2*sin(j*(TWO_PI/sides)));
      a[1]=new Vec3(-len,r1*cos(j*(TWO_PI/sides)),r1*sin(j*(TWO_PI/sides)));
      a[2]=new Vec3(-len,r1*cos((j+1)*(TWO_PI/sides)),r1*sin((j+1)*(TWO_PI/sides)));
      a[3]=new Vec3(len,r2*cos((j+1)*(TWO_PI/sides)),r2*sin((j+1)*(TWO_PI/sides)));
      
      //pitch, then heading
      for(int i = 0; i < a.length;i++){
        float _x=a[i].x;
        float _y=a[i].y;
        a[i].x=_x*cos(pitch)+_y*cos(pitch+HALF_PI);
        a[i].y=_x*sin(pitch)+_y*sin(pitch+HALF_PI);
      }      
      for(int i = 0; i < a.length;i++){
        float _z=a[i].z;
        float _x=a[i].x;
        a[i].z = _z * cos(heading)+_x*cos(heading+HALF_PI);
        a[i].x = _z * sin(heading)+_x*sin(heading+HALF_PI);
      }
      //move tube so that it goes from one end to the other.      
      for(int i = 0; i < a.length;i++){
        a[i].x += mid.x;
        a[i].y += mid.y;
        a[i].z += mid.z;
      }
      polys[j]=new Quad(a[0],a[1],a[2],a[3]);
    }
  }      
  //does exactly what it says.
  void draw(){
    for(int i = 0; i < polys.length; i++)
    {
      polys[i].draw();
    }
  }
}
//4 sided poly, again, saves us having to keep track of 12 floats (4 corners, 3 values per Vec3...)
class Quad{
  Vec3[] v;
  Quad(Vec3 a, Vec3 b, Vec3 c, Vec3 d){
    v=new Vec3[4];
    v[0]=a;
    v[1]=b;
    v[2]=c;
    v[3]=d;
  }  
  void draw(){
    beginShape(QUADS);
    vertex(v[0].x,v[0].y,v[0].z);
    vertex(v[1].x,v[1].y,v[1].z);
    vertex(v[2].x,v[2].y,v[2].z);
    vertex(v[3].x,v[3].y,v[3].z);
    endShape();
  }
}
